import { useCssVars as bt, ref as v, reactive as kt, computed as k, onUnmounted as wt, createBlock as O, openBlock as r, Teleport as $t, createElementBlock as u, createCommentVNode as y, withModifiers as Y, normalizeStyle as D, createElementVNode as c, unref as g, renderSlot as b, createVNode as Je, nextTick as Ke, onMounted as Ct, onBeforeUnmount as At, watch as Be, normalizeClass as We, createSlots as Ye, withCtx as w, normalizeProps as de, guardReactiveProps as ve, Fragment as x, renderList as M, mergeProps as Ve, toDisplayString as q, createTextVNode as Ue } from "vue";
import { X as Qe, u as St, c as Ce, o as _t, e as Ae, g as Ge, b as zt, d as Mt, p as he, ak as je, a7 as Lt, R as Tt, G as Ot, i as fe, f as ge, t as Et, a as Pt, q as Dt, r as Nt, al as Xt } from "./index-CPghjYiK.js";
import { u as It } from "./useUserOptionState-BIvW1Kz7.js";
import { u as Ft } from "./useChartAccessibility-BWojgys7.js";
import { u as Ht, U as Rt } from "./usePrinter-CQQY-qJd.js";
import { t as Bt, u as Wt } from "./useResponsive-Cw4oZ8sQ.js";
import { u as qe } from "./useNestedProp-CU48YkIM.js";
import Yt from "./vue-ui-accordion-CeEfKK0H.js";
import Vt from "./BaseIcon-DKy7UvrS.js";
import { _ as Ze } from "./_plugin-vue_export-helper-CHgC5LLL.js";
import { D as Ut } from "./DataTable-Dzjvhx8x.js";
import { L as Gt } from "./Legend-DA7AW7uZ.js";
import { _ as jt } from "./PenAndPaper-DrnoKbYV.js";
import { _ as qt } from "./Shape-BgIny_5C.js";
import Jt from "./vue-ui-skeleton-C9zb9atn.js";
import { _ as Kt } from "./Title-Cs73jjW3.js";
import Qt from "./vue-ui-xy-BD7-_xp5.js";
const Zt = ["xmlns"], ea = { class: "modal-title" }, ta = { class: "modal-body" }, aa = {
  __name: "BaseDraggableDialog",
  props: {
    backgroundColor: { type: String },
    color: { type: String },
    headerBg: { type: String },
    headerColor: { type: String }
  },
  emits: ["close"],
  setup(I, { expose: ye, emit: pe }) {
    bt((i) => ({
      19616867: I.color
    }));
    const me = I, $ = pe, L = v(!1), V = v(!1), l = kt({
      left: window.innerWidth / 2 - 200,
      top: window.innerHeight / 2 - 120,
      width: 400,
      height: 400,
      dragging: !1,
      resizing: !1,
      dragOffsetX: 0,
      dragOffsetY: 0,
      pointerStartX: 0,
      pointerStartY: 0,
      resizeStartW: 0,
      resizeStartH: 0
    });
    function ne() {
      L.value = !0, Ke(() => {
        V.value || (l.left = Math.max(0, window.innerWidth / 2 - l.width / 2), l.top = Math.max(0, window.innerHeight / 2 - l.height / 2), V.value = !0);
      });
    }
    function J() {
      L.value = !1, $("close");
    }
    ye({ open: ne, close: J });
    const U = k(() => ({
      position: "fixed",
      left: `${l.left}px`,
      top: `${l.top}px`,
      width: `${l.width}px`,
      height: `${l.height}px`,
      padding: 0,
      border: "none",
      background: me.backgroundColor,
      boxShadow: "0 4px 24px rgba(0,0,0,0.15)",
      zIndex: 9999,
      overflow: "visible",
      borderRadius: "2px"
    }));
    function E(i) {
      return i.touches && i.touches.length ? { x: i.touches[0].clientX, y: i.touches[0].clientY } : { x: i.clientX, y: i.clientY };
    }
    function K(i) {
      var p;
      (p = i.preventDefault) == null || p.call(i), l.dragging = !0;
      const h = E(i);
      l.dragOffsetX = h.x - l.left, l.dragOffsetY = h.y - l.top, document.addEventListener("mousemove", F), document.addEventListener("mouseup", H), document.addEventListener("touchmove", F, { passive: !1 }), document.addEventListener("touchend", H);
    }
    function F(i) {
      var e;
      if (!l.dragging) return;
      (e = i.preventDefault) == null || e.call(i);
      const h = E(i);
      let p = h.x - l.dragOffsetX, T = h.y - l.dragOffsetY;
      p = Math.max(0, Math.min(p, window.innerWidth - l.width)), T = Math.max(0, Math.min(T, window.innerHeight - l.height)), l.left = p, l.top = T;
    }
    function H() {
      l.dragging = !1, document.removeEventListener("mousemove", F), document.removeEventListener("mouseup", H), document.removeEventListener("touchmove", F), document.removeEventListener("touchend", H);
    }
    function Q(i) {
      var p;
      (p = i.preventDefault) == null || p.call(i), l.resizing = !0;
      const h = E(i);
      l.pointerStartX = h.x, l.pointerStartY = h.y, l.resizeStartW = l.width, l.resizeStartH = l.height, document.addEventListener("mousemove", C), document.addEventListener("mouseup", N), document.addEventListener("touchmove", C, { passive: !1 }), document.addEventListener("touchend", N);
    }
    function C(i) {
      var e;
      if (!l.resizing) return;
      (e = i.preventDefault) == null || e.call(i);
      const h = E(i);
      let p = h.x - l.pointerStartX, T = h.y - l.pointerStartY;
      l.width = Math.max(240, l.resizeStartW + p), l.height = Math.max(400, l.resizeStartH + T);
    }
    function N() {
      l.resizing = !1, document.removeEventListener("mousemove", C), document.removeEventListener("mouseup", N), document.removeEventListener("touchmove", C), document.removeEventListener("touchend", N);
    }
    function re(i) {
      var p;
      (p = i.preventDefault) == null || p.call(i), l.resizing = !0;
      const h = E(i);
      l.pointerStartX = h.x, l.pointerStartY = h.y, l.resizeStartW = l.width, l.resizeStartH = l.height, l.resizeStartLeft = l.left, l.resizeStartTop = l.top, document.addEventListener("mousemove", R), document.addEventListener("mouseup", f), document.addEventListener("touchmove", R, { passive: !1 }), document.addEventListener("touchend", f);
    }
    function R(i) {
      var ee;
      if (!l.resizing) return;
      (ee = i.preventDefault) == null || ee.call(i);
      const h = E(i);
      let p = h.x - l.pointerStartX, T = Math.min(
        Math.max(0, l.resizeStartLeft + p),
        l.resizeStartLeft + l.resizeStartW - 240
        // min width
      ), e = l.resizeStartW - (T - l.resizeStartLeft), S = h.y - l.pointerStartY, Z = Math.max(400, l.resizeStartH + S);
      l.left = T, l.width = e, l.height = Z;
    }
    function f() {
      l.resizing = !1, document.removeEventListener("mousemove", R), document.removeEventListener("mouseup", f), document.removeEventListener("touchmove", R), document.removeEventListener("touchend", f);
    }
    return wt(() => {
      H(), N(), f();
    }), (i, h) => (r(), O($t, { to: "body" }, [
      L.value ? (r(), u("div", {
        key: 0,
        class: "modal vue-ui-draggable-dialog",
        style: D(U.value),
        onClick: h[0] || (h[0] = Y(() => {
        }, ["stop"]))
      }, [
        c("div", {
          class: "modal-header",
          style: D({
            backgroundColor: I.headerBg,
            color: I.headerColor
          })
        }, [
          c("span", {
            class: "drag-handle",
            onMousedown: Y(K, ["stop", "prevent"]),
            onTouchstart: Y(K, ["stop", "prevent"])
          }, [
            (r(), u("svg", {
              xmlns: g(Qe),
              width: "20",
              height: "20",
              viewBox: "0 0 24 24",
              fill: "none",
              stroke: "currentColor",
              "stroke-width": "1",
              "stroke-linecap": "round",
              "stroke-linejoin": "round"
            }, h[1] || (h[1] = [
              c("path", { d: "M5 9m-1 0a1 1 0 1 0 2 0a1 1 0 1 0 -2 0" }, null, -1),
              c("path", { d: "M5 15m-1 0a1 1 0 1 0 2 0a1 1 0 1 0 -2 0" }, null, -1),
              c("path", { d: "M12 9m-1 0a1 1 0 1 0 2 0a1 1 0 1 0 -2 0" }, null, -1),
              c("path", { d: "M12 15m-1 0a1 1 0 1 0 2 0a1 1 0 1 0 -2 0" }, null, -1),
              c("path", { d: "M19 9m-1 0a1 1 0 1 0 2 0a1 1 0 1 0 -2 0" }, null, -1),
              c("path", { d: "M19 15m-1 0a1 1 0 1 0 2 0a1 1 0 1 0 -2 0" }, null, -1)
            ]), 8, Zt))
          ], 32),
          c("span", ea, [
            b(i.$slots, "title", {}, void 0, !0)
          ]),
          c("button", {
            class: "close",
            onClick: J
          }, [
            Je(Vt, {
              name: "close",
              stroke: I.headerColor
            }, null, 8, ["stroke"])
          ])
        ], 4),
        c("div", ta, [
          b(i.$slots, "default", {}, void 0, !0)
        ]),
        c("div", {
          class: "resize-handle",
          onMousedown: Y(Q, ["stop", "prevent"]),
          onTouchstart: Y(Q, ["stop", "prevent"])
        }, null, 32),
        c("div", {
          class: "resize-handle resize-handle-left",
          onMousedown: Y(re, ["stop", "prevent"]),
          onTouchstart: Y(re, ["stop", "prevent"])
        }, null, 32)
      ], 4)) : y("", !0)
    ]));
  }
}, la = /* @__PURE__ */ Ze(aa, [["__scopeId", "data-v-f854cee8"]]), oa = ["id"], sa = ["xmlns", "viewBox"], na = ["id"], ra = ["stop-color"], ia = ["stop-color"], ua = ["stop-color"], ca = ["stop-color"], da = ["id"], va = ["stop-color"], ha = ["stop-color"], fa = ["stop-color"], ga = ["stop-color"], ya = { key: 0 }, pa = ["fill", "d"], ma = ["fill", "stroke", "stroke-width", "d"], xa = ["stroke", "stroke-dasharray", "stroke-width", "d"], ba = ["x1", "y1", "x2", "y2", "stroke", "stroke-width", "stroke-dasharray"], ka = ["cx", "cy", "stroke", "stroke-width", "r", "fill"], wa = ["x", "y", "font-size", "font-weight", "fill", "text-decoration", "onMouseenter", "onClick"], $a = { key: 1 }, Ca = ["font-size", "fill", "font-weight", "transform", "text-anchor"], Aa = ["x", "y", "width", "height", "onMouseenter", "onClick"], Sa = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], _a = ["cx", "cy", "stroke", "stroke-width", "r", "fill"], za = ["x", "y", "text-anchor", "font-size", "fill"], Ma = {
  key: 5,
  class: "vue-data-ui-watermark"
}, La = ["onClick"], Ta = ["innerHTML"], Oa = {
  __name: "vue-ui-ridgeline",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend", "selectDatapoint", "selectX"],
  setup(I, { expose: ye, emit: pe }) {
    const { vue_ui_ridgeline: me } = St(), $ = I, L = k({
      get() {
        return !!$.dataset && $.dataset.length;
      },
      set(a) {
        return a;
      }
    }), V = pe, l = v(null), ne = v(null), J = v(null), U = v(null), E = v(null), K = v(null), F = v(0), H = v(0), Q = v(0), C = v(Ce()), N = v(0), re = v(0), R = v(512), f = v(null), i = v(null), h = v(null), p = v(0);
    function T() {
      const a = qe({
        userConfig: $.config,
        defaultConfig: me
      });
      return a.theme ? {
        ...qe({
          userConfig: Pt.vue_ui_ridgeline[a.theme] || $.config,
          defaultConfig: a
        }),
        customPalette: Et[a.theme] || he
      } : a;
    }
    const e = k({
      get: () => T(),
      set: (a) => a
    }), S = v(Math.min(
      e.value.style.chart.areas.height,
      e.value.style.chart.areas.rowHeight
    )), {
      userOptionsVisible: Z,
      setUserOptionsVisibility: ee,
      keepUserOptionState: Se
    } = It({ config: e.value }), { svgRef: xe } = Ft({ config: e.value.style.chart.title });
    Ct(be), At(() => {
      U.value && U.value.disconnect();
    });
    function be() {
      if (_t($.dataset) ? Ae({
        componentName: "VueUiRidgeline",
        type: "dataset"
      }) : $.dataset.forEach((a, n) => {
        Ge({
          datasetObject: a,
          requiredAttributes: ["name", "datapoints"]
        }).forEach((t) => {
          L.value = !1, Ae({
            componentName: "VueUiRidgeline",
            type: "datasetSerieAttribute",
            property: t,
            index: n
          });
        }), a.datapoints.length && a.datapoints.forEach((t, s) => {
          Ge({
            datasetObject: t,
            requiredAttributes: ["name", "values"]
          }).forEach((o) => {
            L.value = !1, Ae({
              componentName: "VueUiRidgeline",
              type: "datasetSerieAttribute",
              property: `datapoint.${o}`,
              index: `${n}-${s}`
            });
          });
        });
      }), re.value = $.dataset.length, S.value = Math.min(
        e.value.style.chart.areas.height,
        e.value.style.chart.areas.rowHeight
      ), e.value.responsive) {
        const a = Bt(() => {
          const { width: n, height: t } = Wt({
            chart: l.value,
            title: e.value.style.chart.title.text ? ne.value : null,
            legend: e.value.style.chart.legend.show ? J.value : null,
            source: E.value,
            noTitle: K.value,
            padding: e.value.style.chart.padding
          });
          requestAnimationFrame(() => {
            R.value = n, S.value = t / $.dataset.length, p.value = t;
          });
        });
        U.value = new ResizeObserver(a), U.value.observe(l.value.parentNode);
      }
    }
    const { isPrinting: _e, isImaging: ze, generatePdf: Me, generateImage: Le } = Ht({
      elementId: `vue-ui-ridgeline_${C.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-ridgeline",
      options: e.value.userOptions.print
    }), et = k(() => e.value.userOptions.show && !e.value.style.chart.title.text), tt = k(() => zt(e.value.customPalette)), te = v({
      showTable: e.value.table.show
    });
    Be(() => $.config, (a) => {
      e.value = T(), Z.value = !e.value.userOptions.showOnChartHover, be(), F.value += 1, Q.value += 1, S.value = Math.min(
        e.value.style.chart.areas.height,
        e.value.style.chart.areas.rowHeight
      ), te.value.showTable = e.value.table.show;
    }, { deep: !0 }), Be(() => $.dataset, be, { deep: !0 });
    const ke = k(() => e.value.style.chart.areas.height / e.value.style.chart.areas.rowHeight);
    function Te(a) {
      X.value.includes(a) ? X.value = X.value.filter((n) => n !== a) : X.value.push(a), V("selectLegend", j.value);
    }
    const P = k(() => L.value ? $.dataset.map((a, n) => ({
      ...a,
      labelLen: ot(a.name, e.value.style.chart.yAxis.labels.fontSize),
      uid: Ce(),
      datapoints: a.datapoints.map((t, s) => {
        const o = t.color ? Mt(t.color) : tt.value[s] || he[s] || he[s % he.length], d = je(t.name);
        return {
          ...t,
          color: o,
          id: d
        };
      })
    })) : []), Oe = k(() => e.value.style.chart.padding.top + S.value * $.dataset.length + S.value * ke.value), _ = k(() => ({
      fullHeight: m.value.padding.top + m.value.padding.bottom + m.value.height,
      top: m.value.padding.top,
      left: m.value.padding.left,
      right: m.value.width - m.value.padding.right,
      bottom: m.value.padding.top + m.value.height,
      width: m.value.width - (m.value.padding.left + m.value.padding.right)
    })), m = k(() => {
      const a = e.value.style.chart.padding;
      return {
        width: R.value,
        height: Oe.value,
        padding: a
      };
    }), G = k(() => {
      const a = Math.max(...P.value.map((d) => d.labelLen)), n = Math.max(...P.value.flatMap((d) => d.datapoints.map((z) => z.values.length))), t = m.value.padding.left + a + 16 + e.value.style.chart.yAxis.labels.offsetX, s = (_.value.width - t) / n, o = [];
      for (let d = 0; d < n; d += 1)
        o.push({
          selectorX: t + s * d,
          x: t + s * d - s / 2,
          y: _.value.top,
          label: e.value.style.chart.xAxis.labels.values[d] || "",
          index: d,
          width: s,
          height: Oe.value
        });
      return o;
    });
    function at(a) {
      V("selectX", P.value.map((n) => n.datapoints.map((t) => ({
        dp: t,
        selected: t.values[a.index]
      }))));
    }
    function lt(a, n) {
      return a.length * n / 2 + n;
    }
    function Ee(a, n, t) {
      const s = lt(n, t);
      return a + s > _.value.right;
    }
    function ot(a, n, t = "sans-serif") {
      const o = document.createElement("canvas").getContext("2d"), d = typeof n == "number" ? `${n}px` : n;
      return o.font = `${d} ${t}`, o.measureText(a).width;
    }
    const j = k(() => {
      S.value;
      const a = Math.max(...P.value.map((A) => A.labelLen)), n = Math.max(...P.value.flatMap((A) => A.datapoints.map((B) => B.values.length))), t = Math.max(...P.value.flatMap((A) => A.datapoints.flatMap((B) => B.values))), s = Math.min(...P.value.flatMap((A) => A.datapoints.flatMap((B) => B.values))), o = m.value.padding.left + a + 16 + e.value.style.chart.yAxis.labels.offsetX, d = (_.value.width - o) / n, z = Math.abs(Math.min(s, 0)), Fe = t + z;
      function He(A) {
        return isNaN(A / Fe) ? 0 : A / Fe;
      }
      return P.value.map((A, B) => {
        const Re = _.value.top + S.value * B, W = _.value.top + Re + S.value * ke.value * (1 - He(z));
        return {
          ...A,
          label: {
            x: o - e.value.style.chart.yAxis.labels.fontSize,
            y: W
          },
          datapoints: A.datapoints.map((le) => {
            const oe = le.values.map((se, gt) => {
              const yt = isNaN(se) || [void 0, null, "NaN", NaN, 1 / 0, -1 / 0].includes(se) ? 0 : se || 0, pt = o + d * gt, mt = _.value.top + Re + S.value * ke.value * (1 - He(yt + z)), xt = se === Math.max(...le.values);
              return {
                x: pt,
                y: mt,
                value: se,
                isMaxPoint: xt,
                zero: W
              };
            }), vt = `${Lt(oe, W, !1, !1)}`, ht = `M ${o},${W} ${Tt(oe)} ${oe.at(-1).x},${W}`, ft = `M ${o},${W} ${oe.at(-1).x},${W}`;
            return {
              ...le,
              uid: Ce(),
              plots: oe,
              smoothPath: vt,
              straightPath: ht,
              zeroPath: ft
            };
          }).filter((le) => !X.value.includes(le.id))
        };
      });
    }), X = v([]);
    function st(a) {
      const n = /* @__PURE__ */ new Map();
      return a.forEach((t) => {
        t.datapoints.forEach((s, o) => {
          const d = je(s.name);
          n.has(d) || n.set(d, {
            id: d,
            name: s.name,
            color: s.color,
            shape: "circle",
            segregate: () => Te(d),
            isSegregated: X.value.includes(d),
            opacity: X.value.includes(d) ? 0.5 : 1
          });
        });
      }), Array.from(n.values());
    }
    const ie = k(() => st(P.value)), nt = k(() => ({
      cy: "donut-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), ae = v(!1);
    function rt(a) {
      ae.value = a, N.value += 1;
    }
    const Pe = v({}), De = v([]);
    function it(a) {
      V("selectDatapoint", a), e.value.style.chart.dialog.show && (De.value = a.datapoints.map((n) => ({
        name: n.name,
        color: n.color,
        type: "line",
        useArea: !0,
        smooth: e.value.style.chart.areas.smooth,
        series: n.values
      })), i.value = a, Pe.value = Xt({
        ...e.value.style.chart.dialog.xyChart,
        responsive: !0,
        // Overriding 
        chart: {
          ...e.value.style.chart.dialog.xyChart.chart,
          grid: {
            ...e.value.style.chart.dialog.xyChart.chart.grid,
            labels: {
              ...e.value.style.chart.dialog.xyChart.chart.grid.labels,
              xAxisLabels: {
                ...e.value.style.chart.dialog.xyChart.chart.grid.labels.xAxisLabels,
                values: e.value.style.chart.xAxis.labels.values
                // Overriding
              }
            }
          },
          tooltip: {
            ...e.value.style.chart.dialog.xyChart.chart.tooltip,
            showTimeLabel: e.value.style.chart.xAxis.labels.values.length > 0
            // Overriding
          }
        }
      }), h.value && h.value.open());
    }
    const we = v(null);
    function ut(a) {
      we.value = a;
    }
    function ct() {
      we.value = null;
    }
    const ue = v(!1);
    function $e() {
      ue.value = !ue.value;
    }
    function Ne() {
      te.value.showTable = !te.value.showTable;
    }
    const Xe = k(() => ({ body: j.value.flatMap((t) => t.datapoints.flatMap((s) => ({
      ...s,
      rowName: `${t.name}: ${s.name}`
    }))).map((t) => [
      {
        name: t.rowName,
        color: t.color
      },
      ...t.values
    ]) })), ce = k(() => {
      const a = [
        e.value.table.columnNames.series,
        ...e.value.style.chart.xAxis.labels.values
      ], n = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          ...e.value.style.chart.xAxis.labels.values
        ],
        head: a,
        body: Xe.value.body,
        config: n
      };
    });
    function Ie() {
      Ke(() => {
        const a = [
          [e.value.table.columnNames.series, ...e.value.style.chart.xAxis.labels.values.map((s) => [s])],
          ...Xe.value.body.map((s, o) => [s[0].name, ...s.slice(1)])
        ], n = [
          [e.value.style.chart.title.text],
          [e.value.style.chart.title.subtitle.text]
        ].concat(a), t = Dt(n);
        Nt({
          csvContent: t,
          title: e.value.style.chart.title.text || "vue-ui-ridgeline"
        });
      });
    }
    function dt() {
      return j.value;
    }
    return ye({
      getData: dt,
      generateImage: Le,
      generatePdf: Me,
      generateCsv: Ie,
      toggleAnnotator: $e,
      toggleTable: Ne
    }), (a, n) => (r(), u("div", {
      ref_key: "ridgelineChart",
      ref: l,
      class: We(`vue-ui-ridgeline ${ae.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      id: `vue-ui-ridgeline_${C.value}`,
      style: D({
        fontFamily: e.value.style.fontFamily,
        width: "100%",
        textAlign: "center",
        background: e.value.style.chart.backgroundColor,
        height: e.value.responsive ? "100%" : void 0
      }),
      onMouseenter: n[4] || (n[4] = () => g(ee)(!0)),
      onMouseleave: n[5] || (n[5] = () => g(ee)(!1))
    }, [
      e.value.userOptions.buttons.annotator && g(xe) ? (r(), O(jt, {
        key: 0,
        color: e.value.style.chart.color,
        backgroundColor: e.value.style.chart.backgroundColor,
        active: ue.value,
        svgRef: g(xe),
        onClose: $e
      }, null, 8, ["color", "backgroundColor", "active", "svgRef"])) : y("", !0),
      b(a.$slots, "userConfig", {}, void 0, !0),
      et.value ? (r(), u("div", {
        key: 1,
        ref_key: "noTitle",
        ref: K,
        class: "vue-data-ui-no-title-space",
        style: "height:36px; width: 100%;background:transparent"
      }, null, 512)) : y("", !0),
      e.value.style.chart.title.text ? (r(), u("div", {
        key: 2,
        ref_key: "chartTitle",
        ref: ne,
        style: "width:100%;background:transparent;padding-bottom:24px"
      }, [
        (r(), O(Kt, {
          key: `title_${F.value}`,
          config: {
            title: {
              cy: "ridgeline-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "ridgeline-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : y("", !0),
      e.value.userOptions.show && L.value && (g(Se) || g(Z)) ? (r(), O(Rt, {
        ref: "details",
        key: `user_option_${N.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: g(_e),
        isImaging: g(ze),
        uid: C.value,
        hasTooltip: !1,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasLabel: !1,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: ae.value,
        chartElement: l.value,
        position: e.value.userOptions.position,
        isTooltip: !1,
        titles: { ...e.value.userOptions.buttonTitles },
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: ue.value,
        style: D({
          visibility: g(Se) ? g(Z) ? "visible" : "hidden" : "visible"
        }),
        onToggleFullscreen: rt,
        onGeneratePdf: g(Me),
        onGenerateCsv: Ie,
        onGenerateImage: g(Le),
        onToggleTable: Ne,
        onToggleAnnotator: $e
      }, Ye({ _: 2 }, [
        a.$slots.menuIcon ? {
          name: "menuIcon",
          fn: w(({ isOpen: t, color: s }) => [
            b(a.$slots, "menuIcon", de(ve({ isOpen: t, color: s })), void 0, !0)
          ]),
          key: "0"
        } : void 0,
        a.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: w(() => [
            b(a.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        a.$slots.optionPdf ? {
          name: "optionPdf",
          fn: w(() => [
            b(a.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        a.$slots.optionCsv ? {
          name: "optionCsv",
          fn: w(() => [
            b(a.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        a.$slots.optionImg ? {
          name: "optionImg",
          fn: w(() => [
            b(a.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        a.$slots.optionTable ? {
          name: "optionTable",
          fn: w(() => [
            b(a.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        a.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: w(({ toggleFullscreen: t, isFullscreen: s }) => [
            b(a.$slots, "optionFullscreen", de(ve({ toggleFullscreen: t, isFullscreen: s })), void 0, !0)
          ]),
          key: "6"
        } : void 0,
        a.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: w(({ toggleAnnotator: t, isAnnotator: s }) => [
            b(a.$slots, "optionAnnotator", de(ve({ toggleAnnotator: t, isAnnotator: s })), void 0, !0)
          ]),
          key: "7"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasImg", "hasXls", "hasTable", "hasFullscreen", "isFullscreen", "chartElement", "position", "titles", "hasAnnotator", "isAnnotation", "style", "onGeneratePdf", "onGenerateImage"])) : y("", !0),
      L.value ? (r(), u("svg", {
        key: 4,
        ref_key: "svgRef",
        ref: xe,
        xmlns: g(Qe),
        class: We({ "vue-data-ui-fullscreen--on": ae.value, "vue-data-ui-fulscreen--off": !ae.value }),
        viewBox: `0 0 ${m.value.width <= 0 ? 10 : m.value.width} ${_.value.fullHeight <= 0 ? 10 : _.value.fullHeight}`,
        style: D(`max-width:100%;overflow:visible;background:transparent;color:${e.value.style.chart.color};${e.value.responsive ? `height: ${p.value}px; width: 100%;` : ""}`)
      }, [
        c("defs", null, [
          (r(!0), u(x, null, M(ie.value, (t, s) => (r(), u("linearGradient", {
            id: `gradient-${t.id}-${C.value}`,
            x1: "50%",
            y1: "0%",
            x2: "50%",
            y2: "100%"
          }, [
            c("stop", {
              offset: "0%",
              "stop-color": t.color,
              "stop-opacity": "1"
            }, null, 8, ra),
            c("stop", {
              offset: "30%",
              "stop-color": t.color,
              "stop-opacity": "0.7"
            }, null, 8, ia),
            c("stop", {
              offset: "70%",
              "stop-color": t.color,
              "stop-opacity": "0.3"
            }, null, 8, ua),
            c("stop", {
              offset: "100%",
              "stop-color": t.color,
              "stop-opacity": "0.1"
            }, null, 8, ca)
          ], 8, na))), 256)),
          (r(!0), u(x, null, M(j.value, (t, s) => (r(), u(x, null, [
            (r(!0), u(x, null, M(t.datapoints, (o, d) => (r(), u("linearGradient", {
              key: `grad${o.id}`,
              id: `gradient-single-${C.value}-${o.uid}`,
              x1: "50%",
              y1: "0%",
              x2: "50%",
              y2: "100%"
            }, [
              c("stop", {
                offset: "0%",
                "stop-color": o.color,
                "stop-opacity": "1"
              }, null, 8, va),
              c("stop", {
                offset: "30%",
                "stop-color": o.color,
                "stop-opacity": "0.7"
              }, null, 8, ha),
              c("stop", {
                offset: "70%",
                "stop-color": o.color,
                "stop-opacity": "0.3"
              }, null, 8, fa),
              c("stop", {
                offset: "100%",
                "stop-color": o.color,
                "stop-opacity": "0.1"
              }, null, 8, ga)
            ], 8, da))), 128))
          ], 64))), 256))
        ]),
        a.$slots.pattern ? (r(), u("g", ya, [
          (r(!0), u(x, null, M(ie.value, (t, s) => (r(), u("defs", null, [
            b(a.$slots, "pattern", Ve({ ref_for: !0 }, { variable: t, patternId: `pattern_${C.value}_${s}` }), void 0, !0)
          ]))), 256))
        ])) : y("", !0),
        (r(!0), u(x, null, M(j.value, (t, s) => (r(), u("g", {
          key: `ds-${s}`
        }, [
          (r(!0), u(x, null, M(t.datapoints, (o, d) => (r(), u("g", {
            key: o.id
          }, [
            c("path", {
              fill: e.value.style.chart.backgroundColor,
              stroke: "none",
              "stroke-linecap": "round",
              d: e.value.style.chart.areas.smooth ? o.smoothPath : o.straightPath,
              style: D({ opacity: e.value.style.chart.areas.opacity })
            }, null, 12, pa),
            c("path", {
              fill: e.value.style.chart.areas.useCommonColor ? `url(#gradient-${o.id}-${C.value})` : `url(#gradient-single-${C.value}-${o.uid})`,
              stroke: e.value.style.chart.areas.stroke.useSerieColor ? o.color : e.value.style.chart.areas.stroke.color,
              "stroke-width": e.value.style.chart.areas.strokeWidth,
              d: e.value.style.chart.areas.smooth ? o.smoothPath : o.straightPath,
              "stroke-linecap": "round",
              "stroke-linejoin": "round"
            }, null, 8, ma),
            c("path", {
              stroke: e.value.style.chart.zeroLine.useSerieColor ? o.color : e.value.style.chart.zeroLine.stroke,
              "stroke-dasharray": e.value.style.chart.zeroLine.strokeDasharray,
              "stroke-width": e.value.style.chart.zeroLine.strokeWidth,
              d: o.zeroPath,
              "stroke-linecap": "round"
            }, null, 8, xa),
            e.value.style.chart.areas.maxPoint.show && o.plots.length > 1 ? (r(!0), u(x, { key: 0 }, M(o.plots, (z) => (r(), u(x, null, [
              z.isMaxPoint ? (r(), u("line", {
                key: 0,
                x1: z.x,
                y1: z.y,
                x2: z.x,
                y2: z.zero,
                stroke: e.value.style.chart.areas.maxPoint.adaptStrokeToBackground ? g(Ot)(o.color) : e.value.style.chart.areas.maxPoint.stroke,
                "stroke-width": e.value.style.chart.areas.maxPoint.strokeWidth,
                "stroke-linecap": "round",
                "stroke-dasharray": e.value.style.chart.areas.maxPoint.strokeDasharray
              }, null, 8, ba)) : y("", !0)
            ], 64))), 256)) : y("", !0),
            o.plots.length === 1 ? (r(), u("circle", {
              key: 1,
              cx: o.plots[0].x,
              cy: o.plots[0].y,
              stroke: e.value.style.chart.selector.dot.stroke,
              "stroke-width": e.value.style.chart.selector.dot.strokeWidth,
              r: e.value.style.chart.selector.dot.radius,
              fill: e.value.style.chart.selector.dot.useDatapointColor ? o.color : e.value.style.chart.selector.dot.fill,
              style: {
                pointerEvents: "none"
              }
            }, null, 8, ka)) : y("", !0)
          ]))), 128)),
          c("text", {
            x: t.label.x,
            y: t.label.y,
            "text-anchor": "end",
            "font-size": e.value.style.chart.yAxis.labels.fontSize,
            "font-weight": e.value.style.chart.yAxis.labels.bold ? "bold" : "normal",
            fill: e.value.style.chart.yAxis.labels.color,
            style: D({
              cursor: e.value.style.chart.dialog.show ? "pointer" : "default"
            }),
            "text-decoration": e.value.style.chart.dialog.show && (we.value === s || i.value && t.uid === i.value.uid) ? "underline" : "",
            onMouseenter: (o) => ut(s),
            onMouseleave: ct,
            onClick: (o) => it(t)
          }, q(t.name), 45, wa)
        ]))), 128)),
        e.value.style.chart.xAxis.labels.values.length ? (r(), u("g", $a, [
          (r(!0), u(x, null, M(G.value, (t, s) => b(a.$slots, "time-label", Ve({ ref_for: !0 }, {
            show: t && !e.value.style.chart.xAxis.labels.showOnlyFirstAndLast && !e.value.style.chart.xAxis.labels.showOnlyAtModulo || t && e.value.style.chart.xAxis.labels.showOnlyFirstAndLast && (s === 0 || s === G.value.length - 1) || t && f.value && f.value.index === s || t && !e.value.style.chart.xAxis.labels.showOnlyFirstAndLast && e.value.style.chart.xAxis.labels.showOnlyAtModulo && s % Math.floor(G.value.length / e.value.style.chart.xAxis.labels.modulo) === 0,
            fontSize: e.value.style.chart.xAxis.labels.fontSize,
            content: t.label,
            textAnchor: e.value.style.chart.xAxis.labels.rotation > 0 ? "start" : e.value.style.chart.xAxis.labels.rotation < 0 ? "end" : "middle",
            fill: e.value.style.chart.xAxis.labels.color,
            transform: `translate(${t.selectorX}, ${_.value.top + t.height + e.value.style.chart.xAxis.labels.offsetY}), rotate(${e.value.style.chart.xAxis.labels.rotation})`,
            x: t.selectorX,
            y: _.value.top + t.height + e.value.style.chart.xAxis.labels.offsetY
          }), () => [
            t && !e.value.style.chart.xAxis.labels.showOnlyFirstAndLast && !e.value.style.chart.xAxis.labels.showOnlyAtModulo || t && e.value.style.chart.xAxis.labels.showOnlyFirstAndLast && (s === 0 || s === G.value.length - 1) || t && f.value && f.value.index === s || t && !e.value.style.chart.xAxis.labels.showOnlyFirstAndLast && e.value.style.chart.xAxis.labels.showOnlyAtModulo && s % Math.floor(G.value.length / e.value.style.chart.xAxis.labels.modulo) === 0 ? (r(), u("text", {
              key: 0,
              "font-size": e.value.style.chart.xAxis.labels.fontSize,
              fill: e.value.style.chart.xAxis.labels.color,
              "font-weight": e.value.style.chart.xAxis.labels.bold ? "bold" : "normal",
              transform: `translate(${t.selectorX}, ${_.value.top + t.height + e.value.style.chart.xAxis.labels.offsetY}), rotate(${e.value.style.chart.xAxis.labels.rotation})`,
              "text-anchor": e.value.style.chart.xAxis.labels.rotation > 0 ? "start" : e.value.style.chart.xAxis.labels.rotation < 0 ? "end" : "middle",
              style: D({
                opacity: f.value ? f.value.index === s ? 1 : 0.2 : 1
              })
            }, q(t.label), 13, Ca)) : y("", !0)
          ], !0)), 256))
        ])) : y("", !0),
        c("g", null, [
          (r(!0), u(x, null, M(G.value, (t, s) => (r(), u("rect", {
            x: t.x,
            y: t.y,
            width: t.width < 0 ? 0.1 : t.width,
            height: t.height < 0 ? 0.1 : t.height,
            fill: "transparent",
            onMouseenter: (o) => f.value = t,
            onMouseleave: n[0] || (n[0] = (o) => f.value = null),
            onClick: () => at(t)
          }, null, 40, Aa))), 256)),
          e.value.style.chart.selector.show && f.value ? (r(), u("line", {
            key: 0,
            x1: f.value.selectorX,
            x2: f.value.selectorX,
            y1: f.value.y,
            y2: f.value.y + f.value.height - S.value / 2,
            stroke: e.value.style.chart.selector.stroke,
            "stroke-width": e.value.style.chart.selector.strokeWidth,
            "stroke-dasharray": e.value.style.chart.selector.strokeDasharray,
            "stroke-linecap": "round",
            style: { pointerEvents: "none" }
          }, null, 8, Sa)) : y("", !0),
          f.value ? (r(!0), u(x, { key: 1 }, M(j.value, (t) => (r(), u(x, null, [
            (r(!0), u(x, null, M(t.datapoints, (s) => (r(), u(x, null, [
              (r(!0), u(x, null, M(s.plots, (o, d) => (r(), u(x, null, [
                f.value && f.value.index === d ? (r(), u("circle", {
                  key: 0,
                  cx: o.x,
                  cy: o.y,
                  stroke: e.value.style.chart.selector.dot.stroke,
                  "stroke-width": e.value.style.chart.selector.dot.strokeWidth,
                  r: e.value.style.chart.selector.dot.radius,
                  fill: e.value.style.chart.selector.dot.useDatapointColor ? s.color : e.value.style.chart.selector.dot.fill,
                  style: {
                    pointerEvents: "none"
                  }
                }, null, 8, _a)) : y("", !0),
                f.value && f.value.index === d ? (r(), u("text", {
                  key: 1,
                  x: Ee(
                    o.x,
                    g(fe)(
                      e.value.style.chart.selector.labels.formatter,
                      o.value,
                      g(ge)({
                        p: e.value.style.chart.xAxis.labels.prefix,
                        v: o.value,
                        s: e.value.style.chart.xAxis.labels.suffix,
                        r: e.value.style.chart.selector.labels.rounding
                      })
                    ),
                    e.value.style.chart.selector.labels.fontSize
                  ) ? o.x - e.value.style.chart.selector.labels.fontSize / 2 : o.x + e.value.style.chart.selector.labels.fontSize / 2,
                  y: o.y + e.value.style.chart.selector.labels.fontSize / 3,
                  "text-anchor": Ee(
                    o.x,
                    g(fe)(
                      e.value.style.chart.selector.labels.formatter,
                      o.value,
                      g(ge)({
                        p: e.value.style.chart.xAxis.labels.prefix,
                        v: o.value,
                        s: e.value.style.chart.xAxis.labels.suffix,
                        r: e.value.style.chart.selector.labels.rounding
                      })
                    ),
                    e.value.style.chart.selector.labels.fontSize
                  ) ? "end" : "start",
                  "font-size": e.value.style.chart.selector.labels.fontSize,
                  fill: e.value.style.chart.selector.labels.color,
                  style: {
                    pointerEvents: "none"
                  }
                }, q(g(fe)(
                  e.value.style.chart.selector.labels.formatter,
                  o.value,
                  g(ge)({
                    p: e.value.style.chart.xAxis.labels.prefix,
                    v: o.value,
                    s: e.value.style.chart.xAxis.labels.suffix,
                    r: e.value.style.chart.selector.labels.rounding
                  })
                )), 9, za)) : y("", !0)
              ], 64))), 256))
            ], 64))), 256))
          ], 64))), 256)) : y("", !0)
        ]),
        b(a.$slots, "svg", { svg: m.value }, void 0, !0)
      ], 14, sa)) : y("", !0),
      a.$slots.watermark ? (r(), u("div", Ma, [
        b(a.$slots, "watermark", de(ve({ isPrinting: g(_e) || g(ze) })), void 0, !0)
      ])) : y("", !0),
      L.value ? y("", !0) : (r(), O(Jt, {
        key: 6,
        config: {
          type: "ridgeline",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            ridgeline: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      c("div", {
        ref_key: "chartLegend",
        ref: J
      }, [
        e.value.style.chart.legend.show ? (r(), O(Gt, {
          key: `legend_${Q.value}`,
          legendSet: ie.value,
          config: nt.value,
          onClickMarker: n[1] || (n[1] = ({ legend: t }) => Te(t.id))
        }, Ye({
          item: w(({ legend: t }) => [
            c("div", {
              style: D(`opacity:${X.value.includes(t.id) ? 0.5 : 1}`),
              onClick: (s) => t.segregate()
            }, q(t.name), 13, La)
          ]),
          _: 2
        }, [
          a.$slots.pattern ? {
            name: "legend-pattern",
            fn: w(({ legend: t, index: s }) => [
              Je(qt, {
                shape: t.shape,
                radius: 30,
                stroke: "none",
                plot: { x: 30, y: 30 },
                fill: `url(#pattern_${C.value}_${s})`
              }, null, 8, ["shape", "fill"])
            ]),
            key: "0"
          } : void 0
        ]), 1032, ["legendSet", "config"])) : y("", !0),
        b(a.$slots, "legend", { legend: ie.value }, void 0, !0)
      ], 512),
      a.$slots.source ? (r(), u("div", {
        key: 7,
        ref_key: "source",
        ref: E,
        dir: "auto"
      }, [
        b(a.$slots, "source", {}, void 0, !0)
      ], 512)) : y("", !0),
      L.value ? (r(), O(Yt, {
        key: 8,
        hideDetails: "",
        config: {
          open: te.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: w(() => [
          (r(), O(Ut, {
            key: `table_${H.value}`,
            colNames: ce.value.colNames,
            head: ce.value.head,
            body: ce.value.body,
            config: ce.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` :${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: n[2] || (n[2] = (t) => te.value.showTable = !1)
          }, {
            th: w(({ th: t }) => [
              c("div", { innerHTML: t }, null, 8, Ta)
            ]),
            td: w(({ td: t }) => [
              Ue(q(t.name ? t.name : g(fe)(
                e.value.style.chart.selector.labels.formatter,
                t,
                g(ge)({
                  p: e.value.style.chart.xAxis.labels.prefix,
                  v: t,
                  s: e.value.style.chart.xAxis.labels.suffix,
                  r: e.value.table.td.roundingValue
                })
              )), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : y("", !0),
      e.value.style.chart.dialog.show ? (r(), O(la, {
        key: 9,
        ref_key: "dialog",
        ref: h,
        onClose: n[3] || (n[3] = (t) => i.value = null),
        backgroundColor: e.value.style.chart.dialog.backgroundColor,
        color: e.value.style.chart.dialog.color,
        headerBg: e.value.style.chart.dialog.header.backgroundColor,
        headerColor: e.value.style.chart.dialog.header.color
      }, {
        title: w(() => [
          Ue(q(i.value.name), 1)
        ]),
        default: w(() => [
          i.value ? (r(), O(Qt, {
            key: 0,
            config: Pe.value,
            dataset: De.value
          }, null, 8, ["config", "dataset"])) : y("", !0)
        ]),
        _: 1
      }, 8, ["backgroundColor", "color", "headerBg", "headerColor"])) : y("", !0)
    ], 46, oa));
  }
}, Ja = /* @__PURE__ */ Ze(Oa, [["__scopeId", "data-v-31f97bbc"]]);
export {
  Ja as default
};
